org.apache.storm.pmml

## Class RawInputFromCSVSpout

- java.lang.Object
- - org.apache.storm.topology.base.BaseComponent
  - - org.apache.storm.topology.base.BaseRichSpout
    - - org.apache.storm.pmml.RawInputFromCSVSpout

- All Implemented Interfaces:
    Serializable, ISpout, IComponent, IRichSpout

      public class RawInputFromCSVSpout
      extends BaseRichSpout

  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `RawInputFromCSVSpout(File rawInputCsv, List<String> outputFields)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `activate()` Called when a spout has been activated out of a deactivated mode.
    `void` | `close()` Called when an ISpout is going to be shutdown.
    `void` | `deactivate()` Called when a spout has been deactivated.
    `void` | `declareOutputFields(OutputFieldsDeclarer declarer)` Declare the output schema for all the streams of this topology.
    `static RawInputFromCSVSpout` | `newInstance(File csv)`
    `void` | `nextTuple()` When this method is called, Storm is requesting that the Spout emit tuples to the output collector.
    `void` | `open(Map<String,Object> conf, TopologyContext context, SpoutOutputCollector collector)` Called when a task for this component is initialized within a worker on the cluster.

    - ### Methods inherited from class org.apache.storm.topology.base.BaseRichSpout

      `ack, fail`

    - ### Methods inherited from class org.apache.storm.topology.base.BaseComponent

      `getComponentConfiguration`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.storm.topology.IComponent

      `getComponentConfiguration`

- - ### Constructor Detail

    - #### RawInputFromCSVSpout

          public RawInputFromCSVSpout(File rawInputCsv,
                                      List<String> outputFields)
                               throws FileNotFoundException

      Throws:
        `FileNotFoundException`

  - ### Method Detail

    - #### newInstance

          public static RawInputFromCSVSpout newInstance(File csv)
                                                  throws IOException

      Throws:
        `IOException`

    - #### open

          public void open(Map<String,Object> conf,
                           TopologyContext context,
                           SpoutOutputCollector collector)

      Description copied from interface: `ISpout`

      Called when a task for this component is initialized within a worker on the cluster. It provides the spout with the environment in which the spout executes.

      This includes the:

      Parameters:
        `conf` - The Storm configuration for this spout. This is the configuration provided to the topology merged in with cluster configuration on this machine.
        `context` - This object can be used to get information about this task’s place within the topology, including the task id and component id of this task, input and output information, etc.
        `collector` - The collector is used to emit tuples from this spout. Tuples can be emitted at any time, including the open and close methods. The collector is thread-safe and should be saved as an instance variable of this spout object.

    - #### nextTuple

          public void nextTuple()

      Description copied from interface: `ISpout`

      When this method is called, Storm is requesting that the Spout emit tuples to the output collector. This method should be non-blocking, so if the Spout has no tuples to emit, this method should return. nextTuple, ack, and fail are all called in a tight loop in a single thread in the spout task. When there are no tuples to emit, it is courteous to have nextTuple sleep for a short amount of time (like a single millisecond) so as not to waste too much CPU.

    - #### declareOutputFields

          public void declareOutputFields(OutputFieldsDeclarer declarer)

      Description copied from interface: `IComponent`

      Declare the output schema for all the streams of this topology.

      Parameters:
        `declarer` - this is used to declare output stream ids, output fields, and whether or not each output stream is a direct stream

    - #### activate

          public void activate()

      Description copied from interface: `ISpout`

      Called when a spout has been activated out of a deactivated mode. nextTuple will be called on this spout soon. A spout can become activated after having been deactivated when the topology is manipulated using the `storm` client.

      Specified by:
        `activate` in interface `ISpout`
      Overrides:
        `activate` in class `BaseRichSpout`

    - #### deactivate

          public void deactivate()

      Description copied from interface: `ISpout`

      Called when a spout has been deactivated. nextTuple will not be called while a spout is deactivated. The spout may or may not be reactivated in the future.

      Specified by:
        `deactivate` in interface `ISpout`
      Overrides:
        `deactivate` in class `BaseRichSpout`

    - #### close

          public void close()

      Description copied from interface: `ISpout`

      Called when an ISpout is going to be shutdown. There is no guarentee that close will be called, because the supervisor kill -9’s worker processes on the cluster.

      The one context where close is guaranteed to be called is a topology is killed when running Storm in local mode.

      Specified by:
        `close` in interface `ISpout`
      Overrides:
        `close` in class `BaseRichSpout`

Copyright © 2021 The Apache Software Foundation. All rights reserved.